import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.StringTokenizer;

/*
 * Created on 17-Sep-2005
 */

public class GridFiler
{

  public static byte[][] loadGrid(File filename) throws ParseDataException
  {
    try {
      FileInputStream fis = new FileInputStream(filename);
      BufferedReader br = new BufferedReader(new InputStreamReader(fis));

      byte[][] grid = null;
      String line;
      int y = 0;
      while ((line = br.readLine()) != null) {
        StringTokenizer st = new StringTokenizer(line, ",");
        int dimension = st.countTokens();
        if (grid == null) {
          grid = new byte[dimension][dimension];
        }
        for (int x = 0; x < dimension; x++) {
          grid[y][x] = Byte.parseByte(st.nextToken());
        }
        y++;
      }
      br.close();
      fis.close();
      return grid;
    }
    catch (IOException e) {
      throw new ParseDataException("Error reading file", e);
    }
    catch (NumberFormatException e) {
      throw new ParseDataException("Invalid file format - "
          + "expecting comma separated integers", e);
    }
    catch (ArrayIndexOutOfBoundsException e) {
      throw new ParseDataException("Invalid file format - "
          + "grids should be square; all rows should be the same length", e);
    }
  }

  public static void saveGrid(File filename, byte[][] grid) throws IOException
  {
    FileWriter fw = new FileWriter(filename);
    for (int y = 0; y < grid.length; y++) {
      StringBuffer line = new StringBuffer();
      for (int x = 0; x < grid.length; x++) {
        line.append(String.valueOf(grid[y][x]));
        line.append(",");
      }
      line.append("\n");
      fw.write(line.toString());
    }
    fw.flush();
    fw.close();
  }
}
