import java.util.List;

/*
 * Created on 17-Sep-2005
 */

public class InvalidGridException extends Exception
{
  public static final String NONE_FOUND = "No solutions found!";

  public static final String MULTIPLE_FOUND = "Invalid grid - multiple solutions found";

  private List<byte[][]> solutions;

  public InvalidGridException()
  {
    super();
  }

  public InvalidGridException(String message)
  {
    super(message);
  }

  public InvalidGridException(String message, Throwable cause)
  {
    super(message, cause);
  }

  public InvalidGridException(Throwable cause)
  {
    super(cause);
  }

  public InvalidGridException(String message, List<byte[][]> solutions)
  {
    super(message);
    this.solutions = solutions;
  }

  public List<byte[][]> getSolutions()
  {
    return solutions;
  }
}
